#include <metal_stdlib>
using namespace metal;

struct Uniforms
{
    float4x4 modelViewProjectionMatrix;
};

struct Vertex
{
    float3 position [[attribute(0)]];
    float2 texCoords [[attribute(1)]];
};

struct ProjectedVertex
{
    float4 position [[position]];
    float2 texCoords;
};

vertex ProjectedVertex yv_texture_map_vertex(Vertex vert [[stage_in]],
                                             constant Uniforms &uniforms [[buffer(1)]])
{
    ProjectedVertex outVert;
    outVert.position = uniforms.modelViewProjectionMatrix * float4(vert.position, 1);
    outVert.texCoords = vert.texCoords;
    return outVert;
}

fragment float4 yv_texture_map_fragment(ProjectedVertex vert [[stage_in]],
                                        texture2d<float> diffuseTexture [[texture(0)]],
                                        sampler samplr [[sampler(0)]])
{
    return diffuseTexture.sample(samplr, vert.texCoords);
}
